> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Duplicate project with progress

> Duplicate a project and receive progress updates and the final result through server-sent events.



## OpenAPI

````yaml /swagger.json post /base/duplicate-stream
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
tags:
  - name: base
    x-group: project
  - name: base node
    x-group: project node
  - name: base-share
    x-group: project-share
paths:
  /base/duplicate-stream:
    post:
      tags:
        - base
      description: >-
        Duplicate a project and receive progress updates and the final result
        through server-sent events.


        Required token scopes: `base|create`
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                fromBaseId:
                  type: string
                  description: The project to duplicate
                spaceId:
                  type: string
                  description: The space to duplicate the project to
                withRecords:
                  type: boolean
                  description: Whether to duplicate the records
                name:
                  type: string
                  description: The name of the duplicated project
                baseId:
                  type: string
                nodes:
                  type: array
                  items:
                    type: string
                  description: The node IDs to include in the duplication
                shareId:
                  type: string
                  description: >-
                    The share ID when duplicating from a shared project. If
                    provided, will use share permissions instead of base|update
                    permission.
                timeZone:
                  type: string
                  description: >-
                    The IANA time zone to adapt date-related field options (and
                    date filters) to during duplication. Mainly used when
                    applying a template so dates follow the current user
                    environment.
              required:
                - fromBaseId
                - spaceId
      responses:
        '201':
          description: SSE stream with progress events and final duplicated project.
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request POST \
              --url https://app.teable.ai/api/base/duplicate-stream \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --header 'content-type: application/json' \
              --data '{"fromBaseId":"string","spaceId":"string","withRecords":true,"name":"string","baseId":"string","nodes":["string"],"shareId":"string","timeZone":"string"}'
        - lang: JavaScript
          source: |-
            const url = 'https://app.teable.ai/api/base/duplicate-stream';
            const options = {
              method: 'POST',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              },
              body: '{"fromBaseId":"string","spaceId":"string","withRecords":true,"name":"string","baseId":"string","nodes":["string"],"shareId":"string","timeZone":"string"}'
            };

            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: |-
            const http = require('https');

            const options = {
              method: 'POST',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/base/duplicate-stream',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.write(JSON.stringify({
              fromBaseId: 'string',
              spaceId: 'string',
              withRecords: true,
              name: 'string',
              baseId: 'string',
              nodes: ['string'],
              shareId: 'string',
              timeZone: 'string'
            }));
            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            payload =
            "{\"fromBaseId\":\"string\",\"spaceId\":\"string\",\"withRecords\":true,\"name\":\"string\",\"baseId\":\"string\",\"nodes\":[\"string\"],\"shareId\":\"string\",\"timeZone\":\"string\"}"


            headers = {
                'Authorization': "Bearer REPLACE_BEARER_TOKEN",
                'content-type': "application/json"
            }


            conn.request("POST", "/api/base/duplicate-stream", payload, headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````